/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/time.h>
#ifdef __linux__
#include <linux/vt.h>
#endif
#include <string.h>
#include <ggi/libggi.h>
#include "ggi_screensaver.h"

/* I need the contents of ggi_visual ! */
#include <structs.h>

/* register screensavers */
void reg_savers();
void done_savers();
void ge_bounce(ggi_visual_t visual);

/*
 * This structure contains all screensavers in this module:
 */
ggi_saver_list saver_list[] = {
	{ ge_bounce, "Jumping blob"}
};

/*
 * register all screen-savers in the main module
 */
void reg_savers()
{
	int i;
	for (i=0; i<(sizeof(saver_list)/sizeof(ggi_saver_list)); i++) {
		install_saver(saver_list[i].func, saver_list[i].name);
	}
}

/*
 * free resources allocated by the screen-savers
 */
void done_savers()
{
}  

void ge_bounce(ggi_visual_t visual)
{ 
  int c,lx,ly;
  double x,y,dx,dy;
  int xx[256],yy[256];

	ggi_mode mode;
	int xsize, ysize;
	ggiGetMode(visual,&mode);
	xsize=mode.visible.x;
	ysize=mode.visible.y;

  srand(time(NULL));
  lx=x=xsize/2;ly=y=10;
  for(c=0;c<256;c++) xx[c]=yy[c]=5;
  ggiSetGCForeground(visual,c=0);
  ggiFillscreen(visual);
  while(!switchaway&&!ggiKbhit(visual))
  { dx=(rand()%0x1ff)/255.0-1;
    dy=(rand()%0x3ff)/511.0-0.3;
    while(!switchaway&&!ggiKbhit(visual))
    { x+=dx;y+=dy;
      if (x<10||x>xsize-11) {dx=-dx;x+=dx;}
      if (y<10||y>ysize-11) {dy=-dy;y+=dy;}
      if (y<ysize-20) dy+=0.001;
      dx*=.9999;dy*=.9999;
      if (fabs(dx)<1e-2) break;
      if (lx==(int)x&&ly==(int)y) continue;
      c++;c&=0xff;if (!c) c++;
      ggiSetGCForeground(visual,0);
      ggiDrawCircle(visual,xx[c],yy[c],5);
      lx=xx[c]=x;ly=yy[c]=y;
      ggiSetGCForeground(visual,c);
      ggiDrawCircle(visual,xx[c],yy[c],5);
/*      if (!(c&33)) usleep(1);*/
    }
  }
}
