/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/time.h>
#ifdef __linux__
#include <linux/vt.h>
#endif
#include <string.h>
#include <ggi/libggi.h>
#include "ggi_screensaver.h"

#include <structs.h>

/* register screensavers */
void reg_savers();
void done_savers();
void ge_pong(ggi_visual_t visual);

/*
 * This structure contains all screensavers in this module:
 */
ggi_saver_list saver_list[] = {
	{ ge_pong, "Ping Pong"},
};

/*
 * register all screen-savers in the main module
 */
void reg_savers()
{
	int i;
	for (i=0; i<(sizeof(saver_list)/sizeof(ggi_saver_list)); i++) {
		install_saver(saver_list[i].func, saver_list[i].name);
	}
}

/*
 * free resources allocated by the screen-savers
 */
void done_savers()
{
}  


void ge_pong(ggi_visual_t visual)
{ int x,y,dx,dy,h;
	ggi_mode mode;
	int xsize, ysize;
	ggiGetMode(visual,&mode);
	xsize=mode.visible.x;
	ysize=mode.visible.y;

  x=30;y=20;dx=1;dy=1;
  while(1)
  { if (switchaway||ggiKbhit(visual)) break;

    if (!(x&3)) usleep(1);
    if (x==xsize-6||x==5) dx=-dx;
    if (y==ysize-6||y==5) dy=-dy;
    ggiSetGCForeground(visual,0);
    h=y;if (h<10) h=10;if (h>=ysize-10) h=ysize-11;
    ggiDrawBox(visual,0,h-10,5,20);
    ggiDrawBox(visual,xsize-6,h-10,5,20);
    ggiDrawCircle(visual,x,y,3);
    ggiDrawCircle(visual,x,y,2);
    ggiDrawCircle(visual,x,y,1);
    x+=dx;y+=dy;
    ggiSetGCForeground(visual,64);
    ggiDrawCircle(visual,x,y,3);
    ggiDrawCircle(visual,x,y,2);
    ggiDrawCircle(visual,x,y,1);
    ggiSetGCForeground(visual,1);
    h=y;if (h<10) h=10;if (h>=ysize-10) h=ysize-11;
    ggiDrawBox(visual,0,h-10,5,20);
    ggiSetGCForeground(visual,128);
    ggiDrawBox(visual,xsize-6,h-10,5,20);

  }
}
