/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/time.h>
#ifdef __linux__
#include <linux/vt.h>
#endif
#include <string.h>
#include <ggi/libggi.h>
#include "ggi_screensaver.h"

/* register screensavers */
void reg_savers();
void done_savers();
void ge_vesa_blank  (ggi_visual_t visual);
void ge_vesa_blank2 (ggi_visual_t visual);
void ge_vesa_blank3 (ggi_visual_t visual);

/*
 * This structure contains all screensavers in this module:
 */
ggi_saver_list saver_list[] = {
	{ ge_vesa_blank, "Power Standby"},
	{ ge_vesa_blank2,"Power Suspend"},
	{ ge_vesa_blank3,"Power Off"}
};

/*
 * register all screen-savers in the main module
 * (don't allocate memory, but initialize counters and stuff...)
 */
void reg_savers()
{
	int i;
	for (i=0; i<(sizeof(saver_list)/sizeof(ggi_saver_list)); i++) {
		install_saver(saver_list[i].func, saver_list[i].name);
	}
}

/*
 * free resources allocated by the screen-savers, save configuration
 */
void done_savers()
{
}  

#define ggiMonPower(x)

void ge_vesa_blank(ggi_visual_t visual)
{
	ggiMonPower(PWR_STANDBY);
	while(!switchaway&&!ggiKbhit(visual));
	ggiMonPower(PWR_ON); 
}

void ge_vesa_blank2(ggi_visual_t visual)
{
	ggiMonPower(PWR_SUSPEND);
	while(!switchaway&&!ggiKbhit(visual));
	ggiMonPower(PWR_ON); 
}

void ge_vesa_blank3(ggi_visual_t visual)
{
	ggiMonPower(PWR_OFF);
	while(!switchaway&&!ggiKbhit(visual));
	ggiMonPower(PWR_ON); 
}
